# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from cobo_waas2.models.transaction_role_approval_detail import TransactionRoleApprovalDetail
from typing import Optional, Set
from typing_extensions import Self


class TransactionApprovalDetail(BaseModel):
    """
    The approval detail data for transaction.
    """  # noqa: E501
    spender: Optional[TransactionRoleApprovalDetail] = None
    approver: Optional[TransactionRoleApprovalDetail] = None
    address_owner: Optional[TransactionRoleApprovalDetail] = None
    __properties: ClassVar[List[str]] = ["spender", "approver", "address_owner"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransactionApprovalDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of spender
        if self.spender:
            _dict['spender'] = self.spender.to_dict()
        # override the default output from pydantic by calling `to_dict()` of approver
        if self.approver:
            _dict['approver'] = self.approver.to_dict()
        # override the default output from pydantic by calling `to_dict()` of address_owner
        if self.address_owner:
            _dict['address_owner'] = self.address_owner.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransactionApprovalDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "spender": TransactionRoleApprovalDetail.from_dict(obj["spender"]) if obj.get("spender") is not None else None,
            "approver": TransactionRoleApprovalDetail.from_dict(obj["approver"]) if obj.get("approver") is not None else None,
            "address_owner": TransactionRoleApprovalDetail.from_dict(obj["address_owner"]) if obj.get("address_owner") is not None else None
        })
        return _obj


